/* GamePassword v0.9 */
/* Руссифицировано */

#include <amxmodx>
#include <amxmisc>
#include <cstrike>

new cvarPassword[21],cvarBlackScreen,cvarTransfer,cvarSpectatorTime
new bool:pass[33],players[32],password[21],ScreenFade,stime,num,i

public plugin_init() {
	register_plugin("GamePassword","0.9","ZETA [M|E|N]")
	register_message(get_user_msgid("ShowMenu"),"func_block_menu")
	register_message(get_user_msgid("VGUIMenu"),"func_block_menu")
	register_clcmd("set_password","func_set_password",ADMIN_PASSWORD,"")
	register_clcmd("get_password","func_get_password",ADMIN_PASSWORD,"")
	register_clcmd("say /pass","func_say_pass",ADMIN_PASSWORD,"")
	register_clcmd("gp_pass","func_pass",ADMIN_ALL,"")
	register_cvar("gp_password","")
	register_cvar("gp_black_screen","1")
	register_cvar("gp_transfer","1")
	register_cvar("gp_spectator_time","0")
	
	ScreenFade = get_user_msgid("ScreenFade") 
	
	set_task(2.0,"cvarsvalue")
}

public cvarsvalue() {
	get_cvar_string("gp_password",cvarPassword,sizeof(cvarPassword))
	cvarBlackScreen=get_cvar_num("gp_black_screen")
	cvarTransfer=get_cvar_num("gp_transfer")
	cvarSpectatorTime=get_cvar_num("gp_spectator_time")
}

public func_block_menu(msgid,dest,id) {
	get_cvar_string("gp_password",cvarPassword,sizeof(cvarPassword))
	
	if(!equal(cvarPassword,"")) {
		if(pass[id]) return PLUGIN_CONTINUE
		else return PLUGIN_HANDLED
	}
	else return PLUGIN_CONTINUE
	
	return PLUGIN_HANDLED
}

public func_set_password(id,level,cid) {
	if(!cmd_access(id,level,cid,0))
	return PLUGIN_HANDLED
	
	read_argv(1,password,sizeof(password))
	set_cvar_string("gp_password",password)
	
	if(!equali(password,"")) {
		client_print(id,print_console,"[GamePassword] Пароль: %s",password)
		
		if(cvarTransfer) {
			get_players(players,num)
			
			for(i=0;i<num;i++) {
				if(players[i]!=id) {
					cs_set_user_team(players[i],CS_TEAM_SPECTATOR)
					user_kill(players[i], 1)
					
					pass[players[i]]=false
				}
			}
		}
	}
	else client_print(id,print_console,"[GamePassword] Пароль убран")

	return PLUGIN_HANDLED
}

public func_get_password(id,level,cid) {
	if(!cmd_access(id,level,cid,0))
	return PLUGIN_HANDLED
	
	get_cvar_string("gp_password",password,sizeof(password))
	
	if(!equali(password,"")) client_print(id,print_console,"[GamePassword] Пароль: %s",password)
	else client_print(id,print_console,"[GamePassword] Пароль: не установлен")
	return PLUGIN_HANDLED
}

public func_say_pass(id,level,cid) {
	if(!cmd_access(id,level,cid,0))
	return PLUGIN_HANDLED	
	
	if(!equal(cvarPassword,"")) 
		func_menu(id)
		
	return PLUGIN_HANDLED
}

public func_menu(id) {
	new name[32],info[10],menu,num,i
	menu=menu_create("GamePassword","func_menu_handler")
	
	get_players(players,num)
	
	for(i=0;i<num;i++) {
		if(!pass[players[i]]) {
			get_user_name(players[i],name,31)
			num_to_str(players[i],info,9)
			menu_additem(menu,name,info)
		}
	}
	menu_setprop(menu,MPROP_NEXTNAME,"Дальше")
	menu_setprop(menu,MPROP_BACKNAME,"Назад")
	menu_setprop(menu,MPROP_EXITNAME,"Выход")
	
	if(!menu_items(menu))
		return PLUGIN_HANDLED
	
	menu_display(id,menu,0)
	return PLUGIN_HANDLED
}

public func_menu_handler(id,menu,item) {
	if(item<0) return PLUGIN_HANDLED
	
	new data[10],menu,item,accessmenu,callback
	menu_item_getinfo(menu,item,accessmenu,data,9,_,_,callback)
	
	pass_player(str_to_num(data))
	
	func_menu(id)
	return PLUGIN_HANDLED
}

public func_pass(id) {
	read_argv(1,password,sizeof(password))
	
	get_cvar_string("gp_password",cvarPassword,sizeof(cvarPassword))
	
	if(equali(password,cvarPassword)) {
		client_print(id,print_console,"[GamePassword] Пароль принят")
		pass_player(id)
	}
	else client_print(id,print_console,"[GamePassword] Пароль неверен!")
	return PLUGIN_HANDLED
}

public pass_player(id) {
	remove_task(id)
	pass[id]=true
	
	if(cvarBlackScreen) {
		remove_task(id)
		message_begin(MSG_ONE,ScreenFade,{0,0,0},id)
		write_short(1<<0)
		write_short(1<<0)
		write_short(1<<0)
		write_byte(0)
		write_byte(0)
		write_byte(0)
		write_byte(0)
		message_end()
	}
	if(cs_get_user_team(id) == CS_TEAM_SPECTATOR)
		client_cmd(id,"jointeam")
}

public client_putinserver(id) {
	get_cvar_string("gp_password",cvarPassword,sizeof(cvarPassword))
	
	if(!equal(cvarPassword,"")) {
		cs_set_user_team(id,CS_TEAM_SPECTATOR)
		if(cvarBlackScreen) set_task(0.1,"black_screen",id)
		stime=cvarSpectatorTime
		set_task(1.0,"timer",id,_,_,"b")
	}
}

public black_screen(id) {
	if(is_user_connected(id)) {
		message_begin(MSG_ONE,ScreenFade,{0,0,0},id)
		write_short(1<<0)
		write_short(1<<0)
		write_short(1<<2)
		write_byte(0)	
		write_byte(0)
		write_byte(0)
		write_byte(255)
		message_end()
	}
}

public timer(id) {
	if(is_user_connected(id)) {
		if(cvarSpectatorTime) {
			if(stime!=1) {
				stime--
				set_hudmessage(250, 180, 30, 0.21, 0.70, 1, 0.1, 1.0, 0.1, 0.1, 1)
				show_hudmessage(id, "Введите пароль, чтобы зайти в игру^n\
				иначе будете кикнуты через %d секунд%s",stime,stime < 5 ? stime == 1 ? "у":"ы" : "")
			}
			else server_cmd("amx_kick #%d ^"Время истекло...^"",get_user_userid(id))
		}
		else {
			set_hudmessage(250, 180, 30, 0.21, 0.70, 1, 0.1, 1.0, 0.1, 0.1, 1)
			show_hudmessage(id, "Введите пароль, чтобы зайти в игру")
		}
	}
	else remove_task(id)
}

public client_disconnect(id) {
	pass[id]=false
	
	get_players(players,num,"ch")
	
	if(get_playersnum() == 1)
		set_cvar_string("gp_password","")
}
